<%@ Application Language="C#" ClassName="GlobalAsax" %>
<%@ Import Namespace="CuteChat" %>

<script runat="server" Language="C#">

	public override void Init()
	{
		base.Init();

		lock(typeof(CuteChat.ChatSystem))
		{
			if(!CuteChat.ChatSystem.HasStarted)
			{
				CuteChat.ChatProvider.Instance=new CSChatProvider();
				CuteChat.ChatSystem.Start(new CuteChat.AppSystem());
			}
		}
	}

    public class CSChatProvider : ChatProvider
    {
        public override string GetConnectionString()
        {
		    string connectionstring=System.Configuration.ConfigurationSettings.AppSettings["SiteSqlServer"];
		    if(connectionstring==null||connectionstring.Trim()=="")
			    throw(new Exception("Missing appSetting : SiteSqlServer"));
		    return connectionstring.Trim();
        }

        public override AppChatIdentity GetLogonIdentity()
        {
            CommunityServer.Components.User user = CommunityServer.Users.GetUser();
            if (user == null || user.IsAnonymous)
                return null;
            return new AppChatIdentity(user.Username, false, ToUserId(user.Username), HttpContext.Current.Request.UserHostAddress);
        }


        private CommunityServer.Components.User SafeFindUser(string username)
        {
            HttpContext context = HttpContext.Current;
            if (context != null)
                return CommunityServer.Users.FindUserByUsername(username);

            try
            {
                CommunityServer.Components.CSContext csc = CommunityServer.Components.CSContext.Current;

                return CommunityServer.Users.FindUserByUsername(username);
            }
            catch
            {
                return null;
            }
        }

        public override string FindUserLoginName(string nickName)
        {
            CommunityServer.Components.User user = SafeFindUser(nickName);
            if (user == null || user.IsAnonymous)
                return null;
            return user.Username;
        }
        public override bool GetUserInfo(string loginName, ref string nickName, ref bool isAdmin)
        {
            CommunityServer.Components.User user = SafeFindUser(loginName);
            if (user == null || user.IsAnonymous)
                return false;
            nickName = user.Username;
            isAdmin = user.IsAdministrator;
            return true;
        }
        public override bool ValidateUser(string username, string password)
        {  
			//check whether the user is exists
			CommunityServer.Components.User user = CommunityServer.Users.FindUserByUsername(username);
		    
			if (user == null)
				return false;

			//use CommunityServer API to validate the user
		    
			user = new CommunityServer.Components.User();
			user.Username = username;
			user.Password = password;

			CommunityServer.Components.LoginUserStatus status = CommunityServer.Users.ValidUser(user);
		    
			if(status!=CommunityServer.Components.LoginUserStatus.Success)
			{
				return false;
			}
		    
			//FORM-Authentication , 
			System.Web.Security.FormsAuthentication.SetAuthCookie(user.Username, false, "/");

			return true;
        }
    }

</script>